SystemOrganization addCategory: #'Tadp - Prueba - Tests'!
SystemOrganization addCategory: #'Tadp - Prueba'!
SystemOrganization addCategory: #'Tadp - Tp1'!
SystemOrganization addCategory: #'Tadp - Tp1 - Tests'!
SystemOrganization addCategory: #'Tadp - Tp1-Tests'!
SystemOrganization addCategory: #'Tadp - Tp1 '!

Trait named: #PlacasConConsumoPromedio
	uses: {}
	category: 'Tadp - Tp1'!

!PlacasConConsumoPromedio methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:12'!
consumo
	^self consumoPromedio + self consumoCoolers! !

!PlacasConConsumoPromedio methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:13'!
consumoCoolers 
	^self requirement ! !

!PlacasConConsumoPromedio methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:14'!
consumoPromedio 
	^self requirement! !

Trait named: #TecnologiaAnalogica
	uses: {}
	category: 'Tadp - Tp1'!

!TecnologiaAnalogica methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:50'!
definicionMaxima 
	^480! !

Trait named: #TecnologiaDigital
	uses: {}
	category: 'Tadp - Tp1'!

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:50'!
definicionMaxima
	^self ppp*(self tamao/2)! !

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:22'!
ppp
	^self requirement.! !

!TecnologiaDigital methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:22'!
tamao
	^self requirement.! !

TestCase subclass: #Test
	instanceVariableNames: 'pantallaLcd'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1-Tests'!

!Test methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:57'!
setUp
	pantallaLcd:= Lcd new.
	pantallaLcd tamao: 17.
	pantallaLcd ppp:100.! !

!Test methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:57'!
testCompuConsumo
| entrada computadora placa disco cable|
	pantallaLcd tamao: 20.
		
	entrada:= Vga new.
	pantallaLcd entrada: entrada.
	
	computadora := Computadora new.
	placa := GPU new.
	disco := DiscoRigido newMagneticoConRPM: 200.
	cable := Cable new.
	
	cable definicion: 1000.
	
	pantallaLcd cable: cable.
	
	computadora placa: placa.
	computadora pantalla: pantallaLcd.
	computadora disco: disco.
	
	placa resolucionN: 100 M:1000. 
	
	self assert: computadora consumo  equals:82.2.
! !

!Test methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:57'!
testConsumo
	| entrada |

	entrada:= Vga new.
	pantallaLcd entrada: entrada.
	
	self assert: pantallaLcd consumoReal  equals: 68.1! !

!Test methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:53'!
testEntradaCable
	| cable pantalla entrada |
	pantalla:= Crt new.
	cable:= Cable  new.
	entrada := Vga new.
	
	pantalla entrada: entrada.
	cable definicion: 1080.
	pantalla cable: cable.
	
	self assert: pantalla definicionMaximaTotal  equals:480.
	
! !

Object subclass: #Cable
	instanceVariableNames: 'definicion refresco'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Cable methodsFor: 'setters/getters' stamp: 'Christian 4/7/2013 18:53'!
definicion 
	^definicion ! !

!Cable methodsFor: 'setters/getters' stamp: 'Christian 4/7/2013 18:53'!
definicion: cant
	^definicion:= cant! !

!Cable methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:58'!
refrescoMaximo
	^refresco ! !

!Cable methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:58'!
refrescoMaximo:cant
	refresco:= cant! !

Object subclass: #Computadora
	instanceVariableNames: 'placaVideo discoRigido pantalla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Computadora methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:28'!
aptaVideoJuegos
	^(pantalla aptaParaVideoJuegos & placaVideo aptaParaVideoJuegos)! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:28'!
consumo
	^(placaVideo consumo + discoRigido consumo + pantalla consumo)! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:29'!
definicion
	^(pantalla  definicionMaximaTotal)! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/16/2013 23:38'!
disco: valor
	discoRigido := valor! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/17/2013 02:55'!
monitor: valor
	monitor := valor ! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:51'!
pantalla: nuevaPantalla 
	pantalla := nuevaPantalla ! !

!Computadora methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 00:53'!
placa: valor
	placaVideo := valor.
	placaVideo compu: self! !

Object subclass: #DiscoRigido
	instanceVariableNames: 'consumo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!DiscoRigido class methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:50'!
newMagneticoConRPM: cant
	|instancia|
	instancia:= self new.
	instancia consumo:(instancia discoMagnetico:cant).
	^instancia ! !

!DiscoRigido class methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:38'!
newSolidoConConsumo: cant
	|instancia|
	instancia:= self new.
	instancia consumo:cant.
	^instancia ! !

!DiscoRigido methodsFor: 'setter/getter' stamp: 'Christian 4/19/2013 00:36'!
consumo
	^consumo! !

!DiscoRigido methodsFor: 'setter/getter' stamp: 'Christian 4/19/2013 00:36'!
consumo:cant
	^consumo:= cant! !

!DiscoRigido methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:39'!
discoMagnetico: rpm
	^rpm *0.006! !

Object subclass: #Entrada
	instanceVariableNames: 'pantalla'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Entrada subclass: #Av
	uses: TecnologiaAnalogica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Av class
	uses: TecnologiaAnalogica classTrait
	instanceVariableNames: ''!

!Av methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:39'!
consumo
	^self consumoEnPorcentaje: 10! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:46'!
consumo
	 ^0! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:37'!
consumoEnPorcentaje: porcentaje
	^pantalla consumo * porcentaje /100! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Christian 4/16/2013 00:01'!
definicionMaxima
	^pantalla cable definicion.! !

!Entrada methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:30'!
pantalla: nuevaPantalla
	pantalla :=nuevaPantalla ! !

!Entrada methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:50'!
refrescoMaximo
	^50! !

Entrada subclass: #Hdmi
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Hdmi methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:39'!
consumo
	^self consumoEnPorcentaje: 20! !

!Hdmi methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:50'!
refrescoMaximo 
	^240! !

Entrada subclass: #Rf
	uses: TecnologiaAnalogica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Rf class
	uses: TecnologiaAnalogica classTrait
	instanceVariableNames: ''!

Entrada subclass: #Vga
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!Vga methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:36'!
consumo
	^0.001*pantalla ppp! !

!Vga methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:50'!
refrescoMaximo 
	^120! !

Object subclass: #Pantalla
	instanceVariableNames: 'tamao refresco entrada cable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Pantalla subclass: #Crt
	uses: TecnologiaAnalogica
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Crt class
	uses: TecnologiaAnalogica classTrait
	instanceVariableNames: ''!

!Crt methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:28'!
consumo
	^super consumo:5! !

Pantalla subclass: #Lcd
	uses: TecnologiaDigital
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Lcd class
	uses: TecnologiaDigital classTrait
	instanceVariableNames: ''!

!Lcd methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:28'!
consumo
	^super consumo:4! !

!Lcd methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:55'!
ppp
	^ppp! !

!Lcd methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:37'!
ppp: cant
	ppp:=cant! !

!Lcd methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 16:38'!
tamao
	^tamao.! !

Pantalla subclass: #Led
	uses: TecnologiaDigital
	instanceVariableNames: 'ppp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

Led class
	uses: TecnologiaDigital classTrait
	instanceVariableNames: ''!

!Led methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:28'!
consumo
	^super consumo:1! !

!Led methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:55'!
ppp
	^ppp! !

!Led methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:37'!
ppp: cant
	ppp:=cant! !

!Led methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:24'!
smartTv
	self refresco:135! !

!Led methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 16:43'!
tamao
	^tamao.! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:27'!
aptaParaVideoJuegos 
	^refresco >100! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:55'!
cable
	^cable! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:54'!
cable: nuevoCable
	cable:=nuevoCable .! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 11:26'!
consumo: cant
	^cant * tamao! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:34'!
consumoReal
	^self consumo + entrada consumo
	! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:58'!
definicionMaximaTotal
	(entrada definicionMaxima>self definicionMaxima)
	ifTrue: [^self definicionMaxima] ifFalse: [^entrada definicionMaxima]
	! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:30'!
entrada: nuevaEntrada
	entrada:=nuevaEntrada.
	nuevaEntrada pantalla:  self! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:28'!
initialize 
	refresco :=0! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 12:03'!
monitor
	self refresco:120! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 12:03'!
refresco 
	^refresco ! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 12:03'!
refresco: cant
	refresco := cant
	! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/15/2013 23:50'!
sePuedeConectar: cable
	cable definicion < self definicionMaxima ! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/14/2013 11:24'!
tamao
	^tamao! !

!Pantalla methodsFor: 'setters/getters' stamp: 'Christian 4/15/2013 23:36'!
tamao: cant
	tamao:= cant! !

!Pantalla methodsFor: 'as yet unclassified' stamp: 'Christian 4/14/2013 12:04'!
tv
	self refresco:90! !

Object subclass: #PlacaVideo
	instanceVariableNames: 'cantCoolers compu anchoResolucion altoResolucion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

PlacaVideo subclass: #GPU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

!GPU methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:55'!
consumo
	(self cantPixeles  > self definicionPantalla  )
	ifTrue: [^self consumo: self cantPixeles  ] ifFalse:[^self consumo: self definicionMonitor  ]! !

!GPU methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:12'!
consumo: valor
	^(valor * (1/100000)) + self consumoCoolers ! !

PlacaVideo subclass: #OnBoard
	uses: PlacasConConsumoPromedio
	instanceVariableNames: 'consumoPromedio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

OnBoard class
	uses: PlacasConConsumoPromedio classTrait
	instanceVariableNames: ''!

!OnBoard methodsFor: 'as yet unclassified' stamp: 'EmilianoGomar 4/18/2013 17:00'!
aptaParaVideoJuegos
	^false! !

!OnBoard methodsFor: 'setters/getters' stamp: 'Christian 4/19/2013 00:05'!
consumoPromedio
	^consumoPromedio ! !

!OnBoard methodsFor: 'setters/getters' stamp: 'Christian 4/19/2013 00:05'!
consumoPromedio: cant
	consumoPromedio  := cant ! !

PlacaVideo subclass: #PlacaRegular
	uses: PlacasConConsumoPromedio
	instanceVariableNames: 'consumoPromedio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Tadp - Tp1'!

PlacaRegular class
	uses: PlacasConConsumoPromedio classTrait
	instanceVariableNames: ''!

!PlacaRegular methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:10'!
aptaParaVideoJuegos
	^((self cantPixeles ln) / self consumo > 4)! !

!PlacaRegular methodsFor: 'setters/getters' stamp: 'Christian 4/19/2013 00:04'!
consumoPromedio
	^consumoPromedio ! !

!PlacaRegular methodsFor: 'setters/getters' stamp: 'Christian 4/19/2013 00:03'!
consumoPromedio: cant
	consumoPromedio  := cant ! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:08'!
aptaParaVideoJuegos
	^true! !

!PlacaVideo methodsFor: 'setters/getters' stamp: 'Christian 4/19/2013 00:22'!
cantCoolers 
	^cantCoolers ! !

!PlacaVideo methodsFor: 'setters/getters' stamp: 'Christian 4/19/2013 00:10'!
cantCoolers: cant
	cantCoolers := cant! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'Christian 4/18/2013 23:48'!
cantPixeles
	^altoResolucion * anchoResolucion ! !

!PlacaVideo methodsFor: 'setters/getters' stamp: 'Christian 4/18/2013 23:48'!
compu: nuevaCompu
	compu := nuevaCompu ! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:12'!
consumoCoolers 
	^cantCoolers *0.5! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:30'!
definicionPantalla
	^compu definicion  ! !

!PlacaVideo methodsFor: 'as yet unclassified' stamp: 'Christian 4/19/2013 00:11'!
initialize 
	cantCoolers :=0! !

!PlacaVideo methodsFor: 'setters/getters' stamp: 'Christian 4/18/2013 23:47'!
resolucionN: cantN M:cantM
	anchoResolucion :=cantN.
	altoResolucion :=cantM! !
